// ----- ORIENTATION ----- //
//more subsections and explanation can be found within the sections (usually separated in this order 1.Reocurring complex, 2.Reocurring simple, 3.Unique complex, 4.Unique simple,)

//GET PRE-SETS AND VARIABLES READY (line 29)
  //Images section (line 39)
  //Sound section (line 92)
  //Functions section (line 114)
// SETUP (line 193)
//Images allocation (line 219)
  //Reocurring animations (line 220)
  //Reocurring images (line 334)
  //Unique animations (line 347)
  //Unique images (line 390)
//DISPLAY CURRENT SCREEN (line 408)
//REOCURRING FUNCTIONS (line 425)
//MOVEMENT (line 545)
//UNIQUE FUNCTIONS (line 592)
//FIRST SCREEN (line 653)
//INSTRUCTIONS + INTRO (line 697)
//LEVEL 1 OPENING SCREEN (line 711)
//LEVEL 1 (line 723)
//LEVEL 2 OPENING SCREEN (line 770)
//LEVEL 2 (line 782)
//LEVEL 3 OPENING SCREEN (line 883)
//LEVEL 3 (line 895)
//LAST PAGE - WISH (line 1015)
//ADDITIONAL FUNCTIONS (line 1036)

//GET PRE-SETS READY
  //arrays for snow
float [] flakeX1 = new float [500];
float [] flakeX2 = new float [500];
float [] flakeY = new float [500];
float [] flakespeed = new float [500];

  //declare font
PFont eightBit;

//IMAGES SECTION
  //arrays for animations to be cycled through
  //reocurring animations
    //character animation
     //S = Standing, W = Waliking, L = Left, R = Right, U = Up, D = Down
PImage[] SD = new PImage [15];
PImage[] SR = new PImage [15];
PImage[] SL = new PImage [15];
PImage[] SU = new PImage [15];
PImage[] WD = new PImage [6];
PImage[] WR = new PImage [6];
PImage[] WL = new PImage [6];
PImage[] WU = new PImage [6];
      //tree shaking
PImage[] treeanim = new PImage [7];
      //leaver movement
PImage [] leaver = new PImage [4];

    //unique animations
      //first screen BG
PImage[] cover = new PImage [12];
      //found hat screen animation
PImage[] hatdisc = new PImage [5];
      //found list screen pngs
PImage[] gotlist = new PImage [5];
      //my avatar for last screen
PImage[] me = new PImage [12];

    //reocurring images
      //two-page background
PImage openbg;
      //lock image
PImage lockedimg;
      //unlocked/arrow image
PImage arrow;
      //tree image
PImage tree;
      //button pngs
PImage buttonoff;
PImage buttonon;
      //single list png (when dropped)
PImage list;
    //unique images
      //rock for screen 4
PImage rock;
      //hat for screen 4
PImage hat;
      //Timmy for last screen
PImage timmy;
      //last screen BG
PImage lastcover;

  //SOUND SECTION
    //import sound library
import processing.sound.*;
      //create variables for sound files
        //main tune
SoundFile sound;
        //bells
SoundFile bells;
        //leaver
SoundFile leaversound;
        //button when pressed
SoundFile button;
        //next level unlocked
SoundFile success;

      //floats for calculating absolute distance from hidden start point
        //distance X and Y from mouse to "hidden" start button, for pythagoras theorem
float ampX;
float ampY;
        //variable for application of distance
float amplitude;

  //FUNCTIONS SECTION
    //reocurring functions
      // save coordinates of the character
int [] charcoor = {400, 300};
      //bool to test if Timmy can move
boolean movebool = false;
      //int of the current screen
int screen = 0;
      //int for the character facing direction
int movedir = 4;
      //test if in front or behind character
      //leaver
int leaverlayer = 0;
      //tree
int treelayer = 0;
      //save leaver position
int leaverpos = 0;
      //translate action moves of leaver to position
int leavercount = 0;
      //save whether next stage is locked
boolean locked = true;
      //test position of pressure plate
boolean pressed = false;
      //play sound if on pressureplate
boolean buttonplay = true;
      //play sound when next level unlocks
boolean succsound = true;
      //test if player has already seen level info
boolean opening = true;
      //test if tree should be shaking
boolean treeshakebool = false;
      //variable helping count frames for tree shaking
int counttreeani = 0;

    //unique functions
      //bool that makes the bells play just once
boolean bellsbool = false;
      //save rock position
int rockX = 200;
int rockY = 350;
      //test if in front or behind character
        //rock (screen 4)
int rocklayer = 0;
        //list (screen 3)
int listlayer = 0;
      //test if pressure plates are pressed (screen 4)
boolean pressed1 = false;
boolean pressed2 = false;
      //play sound if on pressureplate (screen 4)
boolean buttonplay1 = true;
boolean buttonplay2 = true;
      //test if list should appear (screen 3)
boolean listbool = false;
      //test if list appearing animation is done (screen 3)
boolean listdisplaydone = false;
      //initiate list animation (screen 3)
boolean listanim = false;
      //save list Y position
int listY = 0;
    //test if player picked up
      //list
boolean gotbool = false;
      //heat
boolean hatbool = false;
    //test if hat animations should be playing (screen 4)
boolean hatanim1 = false;
boolean hatanim2 = false;
    //test if hat animations are finished (screen 4)
boolean hatdisplaydone1 = false;
boolean hatdisplaydone2;
    //save hat Y position
int hatY = 0;
    //ensuring proper display of hat animation (worked only 2/3 times without it)
boolean bughatbool = false;
    //ensuring that player has picked up hat 
      //(same problem as with previous; sometimes the code skipped a void, 
      //since it thought it has already done it, but the variable was being assigned in a different place)
boolean gothat = false;


void setup () {
  //BASIC SETUP
  frameRate(10);
  background (120);
  size (900, 636);
  eightBit = createFont("8-BIT.ttf", 12);
  textFont(eightBit);

    //randomize snow
  for (int i = 0; i < 500; i++) {
    flakeX1[i] = random(225, 675);
    flakeX2[i] = random(0, 900);
    flakeY[i] = random(0, height);
    flakespeed[i] = random(1, 5);
  }

  //IMPORT SOUND
  sound = new SoundFile(this, "LastChristmas.mp3");
  bells = new SoundFile(this, "bells.mp3");
  leaversound = new SoundFile(this, "leaver.mp3");
  button = new SoundFile(this, "button.mp3");
  success = new SoundFile (this, "success.wav");
  //start playing main tune
  sound.play();
  sound.loop();

  //ALLOCATE ALL IMAGES
    //REOCURRING ANIMATIONS
      //character animation
        // S = Standing, W = Waliking, L = Left, R = Right, U = Up, D = Down
  SD[0] = loadImage("anim/SD/SD1.png");
  SD[1] = loadImage("anim/SD/SD1.png");
  SD[2] = loadImage("anim/SD/SD1.png");
  SD[3] = loadImage("anim/SD/SD2.png");
  SD[4] = loadImage("anim/SD/SD2.png");
  SD[5] = loadImage("anim/SD/SD2.png");
  SD[6] = loadImage("anim/SD/SD3.png");
  SD[7] = loadImage("anim/SD/SD3.png");
  SD[8] = loadImage("anim/SD/SD3.png");
  SD[9] = loadImage("anim/SD/SD4.png");
  SD[10] = loadImage("anim/SD/SD4.png");
  SD[11] = loadImage("anim/SD/SD4.png");
  SD[12] = loadImage("anim/SD/SD5.png");
  SD[13] = loadImage("anim/SD/SD5.png");
  SD[14] = loadImage("anim/SD/SD5.png");

  SR[0] = loadImage("anim/SR/SR1.png");
  SR[1] = loadImage("anim/SR/SR1.png");
  SR[2] = loadImage("anim/SR/SR1.png");
  SR[3] = loadImage("anim/SR/SR2.png");
  SR[4] = loadImage("anim/SR/SR2.png");
  SR[5] = loadImage("anim/SR/SR2.png");
  SR[6] = loadImage("anim/SR/SR3.png");
  SR[7] = loadImage("anim/SR/SR3.png");
  SR[8] = loadImage("anim/SR/SR3.png");
  SR[9] = loadImage("anim/SR/SR4.png");
  SR[10] = loadImage("anim/SR/SR4.png");
  SR[11] = loadImage("anim/SR/SR4.png");
  SR[12] = loadImage("anim/SR/SR5.png");
  SR[13] = loadImage("anim/SR/SR5.png");
  SR[14] = loadImage("anim/SR/SR5.png");

  SL[0] = loadImage("anim/SL/SL1.png");
  SL[1] = loadImage("anim/SL/SL1.png");
  SL[2] = loadImage("anim/SL/SL1.png");
  SL[3] = loadImage("anim/SL/SL2.png");
  SL[4] = loadImage("anim/SL/SL2.png");
  SL[5] = loadImage("anim/SL/SL2.png");
  SL[6] = loadImage("anim/SL/SL3.png");
  SL[7] = loadImage("anim/SL/SL3.png");
  SL[8] = loadImage("anim/SL/SL3.png");
  SL[9] = loadImage("anim/SL/SL4.png");
  SL[10] = loadImage("anim/SL/SL4.png");
  SL[11] = loadImage("anim/SL/SL4.png");
  SL[12] = loadImage("anim/SL/SL5.png");
  SL[13] = loadImage("anim/SL/SL5.png");
  SL[14] = loadImage("anim/SL/SL5.png");

  SU[0] = loadImage("anim/SU/SU1.png");
  SU[1] = loadImage("anim/SU/SU1.png");
  SU[2] = loadImage("anim/SU/SU1.png");
  SU[3] = loadImage("anim/SU/SU2.png");
  SU[4] = loadImage("anim/SU/SU2.png");
  SU[5] = loadImage("anim/SU/SU2.png");
  SU[6] = loadImage("anim/SU/SU3.png");
  SU[7] = loadImage("anim/SU/SU3.png");
  SU[8] = loadImage("anim/SU/SU3.png");
  SU[9] = loadImage("anim/SU/SU4.png");
  SU[10] = loadImage("anim/SU/SU4.png");
  SU[11] = loadImage("anim/SU/SU4.png");
  SU[12] = loadImage("anim/SU/SU5.png");
  SU[13] = loadImage("anim/SU/SU5.png");
  SU[14] = loadImage("anim/SU/SU5.png");

  WD[0] = loadImage("anim/WD/WD1.png");
  WD[1] = loadImage("anim/WD/WD2.png");
  WD[2] = loadImage("anim/WD/WD3.png");
  WD[3] = loadImage("anim/WD/WD4.png");
  WD[4] = loadImage("anim/WD/WD5.png");
  WD[5] = loadImage("anim/WD/WD6.png");

  WR[0] = loadImage("anim/WR/WR1.png");
  WR[1] = loadImage("anim/WR/WR2.png");
  WR[2] = loadImage("anim/WR/WR3.png");
  WR[3] = loadImage("anim/WR/WR4.png");
  WR[4] = loadImage("anim/WR/WR5.png");
  WR[5] = loadImage("anim/WR/WR6.png");

  WL[0] = loadImage("anim/WL/WL1.png");
  WL[1] = loadImage("anim/WL/WL2.png");
  WL[2] = loadImage("anim/WL/WL3.png");
  WL[3] = loadImage("anim/WL/WL4.png");
  WL[4] = loadImage("anim/WL/WL5.png");
  WL[5] = loadImage("anim/WL/WL6.png");

  WU[0] = loadImage("anim/WU/WU1.png");
  WU[1] = loadImage("anim/WU/WU2.png");
  WU[2] = loadImage("anim/WU/WU3.png");
  WU[3] = loadImage("anim/WU/WU4.png");
  WU[4] = loadImage("anim/WU/WU5.png");
  WU[5] = loadImage("anim/WU/WU6.png");

    //tree shaking animation
  treeanim [0] = loadImage("tree1.png");
  treeanim [1] = loadImage("tree2.png");
  treeanim [2] = loadImage("tree3.png");
  treeanim [3] = loadImage("tree.png");
  treeanim [4] = loadImage("tree5.png");
  treeanim [5] = loadImage("tree6.png");
  treeanim [6] = loadImage("tree7.png");

    //pressure plate pngs
  buttonon = loadImage("buttonon.png");
  buttonoff = loadImage("buttonoff.png");

    //leaver animation
  leaver[0] = loadImage("leaver1.png");
  leaver[1] = loadImage("leaver2.png");
  leaver[2] = loadImage("leaver3.png");
  leaver[3] = loadImage("leaver2.png");

  //REOCURRING IMAGES
    //BG double pages
  openbg = loadImage("OpenBG.png");

    //lock pngs
  lockedimg = loadImage ("locked.png");

    //unlocked png (arrow)
  arrow = loadImage("arrow.png");

    //tree png
  tree = loadImage("tree.png");

  //UNIQUE ANIMATIONS
    //cover animation
  cover[0] = loadImage("6.jpg");
  cover[1] = loadImage("6.jpg");
  cover[2] = loadImage("5.jpg");
  cover[3] = loadImage("5.jpg");
  cover[4] = loadImage("4.jpg");
  cover[5] = loadImage("4.jpg");
  cover[6] = loadImage("3.jpg");
  cover[7] = loadImage("3.jpg");
  cover[8] = loadImage("2.jpg");
  cover[9] = loadImage("2.jpg");
  cover[10] = loadImage("1.jpg");
  cover[11] = loadImage("1.jpg");

    //found list screen pngs
  gotlist[0] = loadImage("gotlist1.png");
  gotlist[1] = loadImage("gotlist2.png");
  gotlist[2] = loadImage("gotlist3.png");
  gotlist[3] = loadImage("gotlist4.png");
  gotlist[4] = loadImage("gotlist5.png");

    //found hat screen pngs
  hatdisc[0] = loadImage("hatdisc1.png");
  hatdisc[1] = loadImage("hatdisc2.png");
  hatdisc[2] = loadImage("hatdisc3.png");
  hatdisc[3] = loadImage("hatdisc4.png");
  hatdisc[4] = loadImage("hatdisc5.png");

    //my avatar animation for last screen
  me[0] = loadImage("ME1.png");
  me[1] = loadImage("ME1.png");
  me[2] = loadImage("ME1.png");
  me[3] = loadImage("ME2.png");
  me[4] = loadImage("ME2.png");
  me[5] = loadImage("ME2.png");
  me[6] = loadImage("ME3.png");
  me[7] = loadImage("ME3.png");
  me[8] = loadImage("ME3.png");
  me[9] = loadImage("ME4.png");
  me[10] = loadImage("ME4.png");
  me[11] = loadImage("ME4.png");

  //UNIQUE IMAGES
    //christmas list png
  list = loadImage("list.png");

    //rock for screen 4 (hat puzzle)
  rock = loadImage("rock.png");

    //hat for screen 4 (hat puzzle)
  hat = loadImage("hatfall.png");

    //closing screen Timmy /w hat
  timmy = loadImage("sickwhitefuck.png");

    //closing screen BG
  lastcover = loadImage("lastcover.png");
}

//DISPLAY CURRENT SCREEN
void draw () {
  if (screen == 0) {
    frontCover ();
  } else if (screen == 1) {
    instructions();
  } else if (screen == 2) {
    intro ();
  } else if (screen == 3) {
    listpuzzle();
  } else if (screen == 4) {
    hatpuzzle();
  } else if (screen == 5) {
    backCover ();
  }
}

//REOCURRING FUNCTIONS
  //preset for levels intro
void openingscreen() {
  background(0);
  textAlign(CENTER, CENTER);
  fill(255);
}
  //snow on one-page creens
void snow1 (int x) {
  for (int i = 0; i < x; i++) {
    fill(230, 230, 255);
    stroke(230, 230, 255);
    rect(flakeX1[i], flakeY[i], 2, 2);
    flakeY[i] += flakespeed[i];
    if (flakeY[i] > height) {
      flakeY[i] = 0;
    }
  }
}
  //snow on two-page creens
void snow2 (int x) {
  for (int i = 0; i < x; i++) {
    fill(230, 230, 255);
    stroke(230, 230, 255);
    rect(flakeX2[i], flakeY[i], 2, 2);
    flakeY[i] += flakespeed[i];
    if (flakeY[i] > height) {
      flakeY[i] = 0;
    }
  }
}
  //initiate tree shaking if close to tree + action pressed
void treeshakevoid () {
  if (charcoor[0] > 90 && charcoor[0] < 210 && charcoor[1] > 220 && charcoor[1] < 280 && keyPressed == true && key == ' ') {
    treeshakebool = true;
  }
}
  //display lock or arrow and play sound if next level locked/unlocked respectively
void displaylockvoid () {
  if (locked == true) {
    image(lockedimg, 850, 570, 50, 51);
    succsound = true;
  } else {
    int arrowmove = (frameCount%4)/2;
    image(arrow, 840 +arrowmove*10, 585, 40, 31);
    if (succsound == true) {
      success.play();
      succsound = false;
    }
  }
}
  //test whether Timmy is behind or in front of leaver
void leavertestposvoid () {
  if (charcoor[1] > 230) {
    leaverlayer = 1;
  } else {
    leaverlayer = 0;
  }
}
  //test whether Timmy is behind or in front of tree
void treetestposvoid () {
  if (charcoor[1] > 230) {
    treelayer = 1;
  } else {
    treelayer = 0;
  }
}
  //if close to leaver, move it and play sound
void leavermovevoid () {
  if (charcoor[0] > 660 && charcoor[0] < 770 && charcoor[1] > 200 && charcoor[1] < 260 && keyPressed == true && key == ' ') {
    leaversound.play();
    leavercount +=1;
    leaverpos = leavercount%4;
  }
}
  //display leaver animation according to leaver position
void leaverposvoidlist () {
  if (leaverpos == 0) {
    image(leaver[0], 700, 250, 72, 53);
  } else if (leaverpos == 1) {
    image(leaver[1], 700, 250, 72, 53);
  } else if (leaverpos == 2) {
    image(leaver[2], 700, 250, 72, 53);
  } else if (leaverpos == 3) {
    image(leaver[3], 700, 250, 72, 53);
  }
}
  //test if tree should be moving, if yes, do it and reset it afterwards
void treeshake() {
  if (treeshakebool == true) {
    if (counttreeani <7) {
      image(treeanim[counttreeani], 100, 100, 147, 220);
    } else {
      image(treeanim[3], 100, 100, 147, 220);
      counttreeani = 0;
      treeshakebool = false;
    }
  }
}
  //stop moving if Timmy encounters obstacle
void not (int dir) {
  movebool = false;
  movedir = dir;
}
  //move Timmy in the according direction (test which one it is)
void move (int dir, int xory, int diff) {
  movebool = true;
  movedir = dir;
  charcoor[xory] +=diff;
  if (dir == 1) {
    image(WL[frameCount%6], charcoor[0], charcoor[1], 100, 147);
  } else if (dir == 2) {
    image(WU[frameCount%6], charcoor[0], charcoor[1], 100, 147);
  } else if (dir == 3) {
    image(WR[frameCount%6], charcoor[0], charcoor[1], 100, 147);
  } else {
    image(WD[frameCount%6], charcoor[0], charcoor[1], 100, 147);
  }
}

  //MOVEMENT
    //test whether encountering obstable -> if yes, stop and stand –> if not, move 
void movement () {
    //LEFT MOVEMENT
  if (keyPressed == true && (keyCode == 37 || key == 'a' || key == 'A')) {
    //block walkin over leaver and
    if ((charcoor[0] -10 == 750 && charcoor[1] > 210 && charcoor[1] < 250) || (charcoor[0] -10 == 190 && charcoor[1] > 230 && charcoor[1] < 270) || (screen == 3 && listbool == true && charcoor[0] -10 == 460 && charcoor[1] > 340 && charcoor[1] < 390) || (charcoor[0] == 10) || (screen == 4 && charcoor[0] == rockX+80 && charcoor[1] >= rockY-20 && charcoor[1] <= rockY +10)) {
      not(1);
    } else {
      move(1, 0, -10);
    }
    //UP MOVEMENT
  } else if (keyPressed == true && (keyCode == 38 || key == 'w' || key == 'W')) {
    if ((charcoor[1] -10 == 240 && charcoor[0] > 670 && charcoor[0] < 760) || (charcoor[1] -10 == 260 && charcoor[0] > 100 && charcoor[0] < 200) || (screen == 3 && listbool == true && charcoor[1] -10 == 390 && charcoor[0] > 380 && charcoor[0] < 470) || (charcoor[1] == 110) || (screen == 4 && charcoor[1] == rockY+20 && charcoor[0] >= rockX-20 && charcoor[0] <= rockX +70)) {
      not(2);
    } else {
      move(2, 1, -10);
    }
    //RIGHT MOVEMENT
  } else if (keyPressed == true && (keyCode == 39 || key == 'd' || key == 'D')) {
    if ((charcoor[0] +10 == 680 && charcoor[1] > 210 && charcoor[1] < 250) || (charcoor[0] +10 == 110 && charcoor[1] > 230 && charcoor[1] < 270) || (screen == 3 && listbool == true && charcoor[0] +10 == 390 && charcoor[1] > 340 && charcoor[1] < 390) || (charcoor[0] == 850 && locked == true) || (screen == 4 && charcoor[0] == rockX-30 && charcoor[1] >= rockY-20 && charcoor[1] <= rockY +10)) {
      not(3);
    } else {
      move(3, 0, 10);
    }
    //DOWN MOVEMENT
  } else if (keyPressed == true && (keyCode == 40 || key == 's' || key == 'S')) { //DOWN
    if ((charcoor[1] +10 == 220 && charcoor[0] > 670 && charcoor[0] < 760) || (charcoor[1] +10 == 240 && charcoor[0] > 100 && charcoor[0] < 200) || (screen == 3 && listbool == true && charcoor[1] +10 == 340 && charcoor[0] > 380 && charcoor[0] < 470) || (charcoor[1] == 480) || (screen == 4 && charcoor[1] == rockY-30 && charcoor[0] >= rockX-20 && charcoor[0] <= rockX +70)) {
      not(4);
    } else {
      move(4, 1, 10);
    }
  }  
  //if standing play appropriate animation
  if (movebool == false) {
    if (movedir == 1) {
      image(SL[frameCount%15], charcoor[0], charcoor[1], 100, 147);
    } else if (movedir == 2) {
      image(SU[frameCount%15], charcoor[0], charcoor[1], 100, 147);
    } else if (movedir == 3) {
      image(SR[frameCount%15], charcoor[0], charcoor[1], 100, 147);
    } else if (movedir == 4) {
      image(SD[frameCount%15], charcoor[0], charcoor[1], 100, 147);
    }
  }
}

//UNIQUE FUNCTIONS
    //unlock next level if leaver is in position 2 on level 1
void leaverposvoidintro () {
  if (leaverpos == 0) {
    image(leaver[0], 700, 250, 72, 53);
    locked = true;
  } else if (leaverpos == 1) {
    image(leaver[1], 700, 250, 72, 53);
    locked = true;
  } else if (leaverpos == 2) {
    locked = false;
    image(leaver[2], 700, 250, 72, 53);
  } else if (leaverpos == 3) {
    image(leaver[3], 700, 250, 72, 53);
    locked = true;
  }
}
  //dispay discovery screen for list upon picking up
void gotlistvoid () {
  if (gotbool == true) {
    image(gotlist[frameCount%5], 0, 0, 900, 636);
  }
}
  //dispay discovery screen for hat upon picking up
void gothatvoid () {
  if (gothat == true) {
    image(hatdisc[frameCount%5], 0, 0, 900, 636);
  }
}
  //display list if the animation has finished (using twice, for testing whether in front or behind)
void listdisplayvoid () {
  if (listdisplaydone == true) {
    image(list, 430, 400, 36, 35);
  }
}
  //recall hat animation for given steps
void hatanimvoid () {
  if (hatanim1 == true) {
    if (hatY == 180) {
      image(hat, 195, hatY, 41, 28);
      hatdisplaydone1 = true;
    } else if (hatY <= 180) {
      image(hat, 195, hatY, 41, 28);
      hatY +=20;
    }
  }
  if (hatdisplaydone1 == true && treeshakebool == true && locked == true) {
    hatanim2 = true;
    hatanim1 = false;
  }
  if (hatanim2 == true) {
    if (hatY == 300) {
      hatdisplaydone2 = true;
      image(hat, 195, hatY, 41, 28);
    } else if (hatY <= 300) {
      image(hat, 195, hatY, 41, 28);
      hatY +=10;
    }
  }
}

//FIRST SCREEN
void frontCover () {
  //basic setup
  background (120);
  rectMode(CORNER);
  fill (255);
  rect (225, 0, 450, 636);
  image(cover[frameCount%12], 225, 0, 450, 636);

  //calculate absolute position from mouse to "hidden" start button
  if (mouseX <=576) {
    ampX = map(mouseX, 0, 576, 0.0, 1.0);
  } else if (mouseX >576) {
    ampX = map(mouseX, 576, 900, 1.0, 0.0);
  }
  if (mouseY <=560) {
    ampY = map(mouseY, 0, 560, 0.0, 0.6);
  } else if (mouseY >560) {
    ampY = map(mouseY, 560, height, 0.6, 0.0);
  }
  //translate distance to amplitude
  amplitude = (ampY*ampX);

  //test if mouse on starting point
  if (mouseX >= 576-25 && mouseX <= 576+25 && mouseY >= 560-20 && mouseY <= 560+20) {
    fill (40, 120, 40);
    //test if player entered start button area
    if (bellsbool == false) {
      bells.play();
      //maximize amplitude if on start button
      amplitude = 1.0;
    }
    //disable repeating bells
    bellsbool = true;
  } else {
    //reset bells upon player leaving start button area
    bellsbool = false;
  }
  //apply sound amplitude
  sound.amp(amplitude);
  //make it snow
  snow1(200);
}

//INSTRUCTIONS + INTRO
void instructions() {
  background(0);
  textAlign(CENTER);
  textSize(20);
  fill(255);
  text("Help Timmy find his hat and his christmas list", width/2, height/2-10);
  textSize(12);
  text("As a thanks he will unlock your Christmas Wish!", width/2, height/2+20);
  text("Press space to proceed", width/2, height/2+200);
  textSize(12);
  text("W A S D or arrows for movement", width/2, height/2+100);
  text("Spacebar for Action", width/2, height/2+120);
}

//LEVEL 1 OPENING SCREEN
void openingscreen1 () {
  openingscreen();
  textSize(30);
  text("PAGE 1", width/2, height/2);
  textSize(15);
  text("tutorial", width/2, height/2+50);
  textSize(10);
  text("try moving the leaver around!", width/2, height/2+100);
  text("CLICK!", width/2, height/2+250);
}

//LEVEL 1
void intro () {
  //initialize tree shake on action
  treeshakevoid();
  image(openbg, 0, 0, 900, 636);
  //display tree image or play animation if behind Timmy
  if (treeshakebool == true && treelayer == 1) {
    treeshake();
  } else if (treelayer == 1) {
    image(tree, 100, 100, 147, 220);
  }
  //display leaver image or play animation if behind Timmy
  if (leaverlayer == 1) {
    leaverposvoidintro ();
  }
  //move or stand
  movement();
  //display tree image or play animation if in front of Timmy
  if (treeshakebool == true && treelayer == 0) {
    treeshake();
  } else if (treelayer == 0) {
    image(tree, 100, 100, 147, 220);
  }
  //display leaver image or play animation if in front of Timmy
  if (leaverlayer == 0) {
    leaverposvoidintro ();
  }
  leavermovevoid ();
  leavertestposvoid();
  treetestposvoid();
  displaylockvoid();
  //allow walking off to right if next level is unlocked
  if (charcoor[0] >= 900 && locked == false) {
    screen = 3;
    reset();
  }
  //make it snow
  snow2(100);
  if (opening == true) {
    openingscreen1();
  }
  //count tree animation frames
  if (treeshakebool == true) {
    counttreeani ++;
  }
}

//LEVEL 2 OPENING SCREEN
void openingscreen2 () {
  openingscreen();
  textSize(30);
  text("PAGE 2", width/2, height/2);
  textSize(15);
  text("the list", width/2, height/2+50);
  textSize(10);
  text("combination under pressure", width/2, height/2+100);
  text("CLICK!", width/2, height/2+250);
}

//LEVEL 2
void listpuzzle() {
  //initialize tree shake on action
  treeshakevoid();
  image(openbg, 0, 0, 900, 636);
  //set conditions for displaying list
  if ((leaverpos == 1 || leaverpos == 3) && pressed == true) {
    listanim = true;
  } else if ((leaverpos == 0 || leaverpos == 2) && pressed == true) {
    listbool = false;
  }
  //display tree image or play animation if behind Timmy
  if (treeshakebool == true && treelayer == 1) {
    treeshake();
  } else if (treelayer == 1) {
    image(tree, 100, 100, 147, 220);
  }
  //test if Timmy is on pressure plate, if yes, press it and play SFX
  if (charcoor[0] >=580 && charcoor[0] <=640 && charcoor[1] >=390 && charcoor[1] <=410) {
    if (buttonplay == true) {
      button.play();
    }
    image(buttonon, 600, 450, 74, 47);
    pressed = true;
    buttonplay = false;
  } else {
    image(buttonoff, 600, 450, 74, 47);
    pressed = false;
    buttonplay = true;
  }
  //display leaver image or play animation if behind Timmy
  if (leaverlayer == 1) {
    leaverposvoidlist();
  }
  //display list image or play animation if behind Timmy
  if (listlayer == 1 && listbool == true) {
    listdisplayvoid ();
  }
  movement ();
  //display tree image or play animation if in front of Timmy
  if (treeshakebool == true && treelayer == 0) {
    treeshake();
  } else if (treelayer == 0) {
    image(tree, 100, 100, 147, 220);
  }
  //display leaver image or play animation if in front of Timmy
  if (leaverlayer == 0) {
    leaverposvoidlist();
  }
  //display list image or play animation if in front of Timmy
  if (listlayer == 0 && listbool == true) {
    listdisplayvoid ();
  }
  leavermovevoid ();
  leavertestposvoid();
  treetestposvoid();
  //test whether Timmy is behind or in front of leaver
  if (charcoor[1] > 370) {
    listlayer = 1;
  } else {
    listlayer = 0;
  }
  //list pickup conditions and apply consequences
  if (charcoor[0] > 370 && charcoor[0] < 480 && charcoor[1] > 330 && charcoor[1] < 410 && keyPressed == true && key == ' ' && listbool == true) {
    gotbool = true;
    listbool = false;
    locked = false;
  }
  displaylockvoid();
  //animate list falling down
  if (listanim == true && listdisplaydone == false) {
    listbool = true;
    if (listY <= 400) {
      image(list, 430, listY, 36, 35);
    }
    listY +=40;
    if (listY == 400) {
      listdisplaydone = true;
    }
  }
  //allow walking off to right if next level is unlocked
  if (charcoor[0] >= 900 && locked == false) {
    screen = 4;
    reset();
  }
  //display list discovery screen upon picking up 
  if (gotbool == true) {
    gotlistvoid ();
  }
  //make it snow
  snow2(300);
  //if player hasn't seen intro to level, display it
  if (opening == true) {
    openingscreen2();
  }
  //count tree animation frames
  if (treeshakebool == true) {
    counttreeani ++;
  }
}

//LEVEL 3 OPENING SCREEN
void openingscreen3 () {
  openingscreen();
  textSize(30);
  text("PAGE 3", width/2, height/2);
  textSize(15);
  text("the hat", width/2, height/2+50);
  textSize(10);
  text("Timmy is buff af", width/2, height/2+100);
  text("CLICK!", width/2, height/2+250);
}

//LEVEL 3
void hatpuzzle () {
  treeshakevoid();
  image(openbg, 0, 0, 900, 636);
  //allow picking up of hat
  if (charcoor[0] > 160 && charcoor[0] < 240 && charcoor[1] > 230 && charcoor[1] < 280 && keyPressed == true && key == ' ' && hatdisplaydone2 == true) {
    hatanim1 = false;
    hatanim2 = false;
    gothat = true;
    locked = false;
  }
  //run pressure plates specific to level 3
  if ((charcoor[0] >=580 && charcoor[0] <=640 && charcoor[1] >=390 && charcoor[1] <=410) || (rockX > 520 && rockX < 680 && rockY == 390)) {
    if (buttonplay1 == true) {
      button.play();
    }
    image(buttonon, 600, 450, 74, 47);
    pressed1 = true;
    buttonplay1 = false;
  } else {
    image(buttonoff, 600, 450, 74, 47);
    pressed1 = false;
    buttonplay1 = true;
  }
  if ((charcoor[0] >=380 && charcoor[0] <=440 && charcoor[1] >=310 && charcoor[1] <=330) || (rockX > 320 && rockX < 480 && rockY > 120 && rockY < 390)) {
    if (buttonplay2 == true) {
      button.play();
    }
    image(buttonon, 400, 370, 74, 47);
    pressed2 = true;
    buttonplay2 = false;
  } else {
    image(buttonoff, 400, 370, 74, 47);
    pressed2 = false;
    buttonplay2 = true;
  }
  //display tree image or play animation if behind Timmy AND continue with hat animation if hat is on tree
  if (treeshakebool == true && treelayer == 1) {
    hatanimvoid();
    treeshake();
  } else if (treelayer == 1) {
    image(tree, 100, 100, 147, 220);
    hatanimvoid();
  }
  //display rock image if behind Timmy
  if (rocklayer == 1) {
    image(rock, rockX, rockY, 96, 82);
  }
  //display leaver image or play animation if behind Timmy
  if (leaverlayer == 1) {
    leaverposvoidlist();
  }
  movement ();
  //display rock image if in front of Timmy
  if (rocklayer == 0) {
    image(rock, rockX, rockY, 96, 82);
  }
  //display tree image or play animation if in front of Timmy
  if (treeshakebool == true && treelayer == 0) {
    hatanimvoid();
    treeshake();
  } else if (treelayer == 0) {
    image(tree, 100, 100, 147, 220);
    hatanimvoid();
  }
  //display leaver image or play animation if in front of Timmy
  if (leaverlayer == 0) {
    leaverposvoidlist();
  }
  //rock pushing functions
    //PUSH LEFT == 1
  if (movedir == 1 && screen == 4 && charcoor[0] == rockX+80 && charcoor[1] >= rockY-30 && charcoor[1] <= rockY +20 && keyPressed == true && key == ' ') {
    rockX -= 40;
  }
    //PUSH UP == 2
  if (movedir == 2 && screen == 4 && charcoor[1] == rockY+20 && charcoor[0] >= rockX-30 && charcoor[0] <= rockX +80 && keyPressed == true && key == ' ') {
    rockY -= 40;
  }
    //PUSH RIGHT == 3
  if (movedir == 3 && screen == 4 && charcoor[0] == rockX-30 && charcoor[1] >= rockY-30 && charcoor[1] <= rockY +20 && keyPressed == true && key == ' ') {
    rockX += 40;
  }
    //PUSH DOWN == 4
  if (movedir == 4 && screen == 4 && charcoor[1] == rockY-30 && charcoor[0] >= rockX-30 && charcoor[0] <= rockX +80 && keyPressed == true && key == ' ') {
    rockY += 40;
  }
  leavermovevoid ();
  leavertestposvoid();
  treetestposvoid();
  displaylockvoid();
  //test whether Timmy is behind or in front of rock
  if (charcoor[1] > rockY-20) {
    rocklayer = 1;
  } else {
    rocklayer = 0;
  }
  //allow walking off to right if next level is unlocked
  if (charcoor[0] >= 900 && locked == false) {
    screen = 5;
    reset();
  }
  //set conditions for displaying hat and initialize it
  if (pressed1 == true && pressed2 == true && leaverpos == 2) {
    hatanim1 = true;
  }
  //display list discovery screen upon picking up 
  if (locked == false) {
    gothatvoid ();
  }
  //make it snow
  snow2(500);
  //if player hasn't seen intro to level, display it
  if (opening == true) {
    openingscreen3();
  }
  //count tree animation frames
  if (treeshakebool == true) {
    counttreeani ++;
  }
}

//LAST PAGE - WISH
void backCover () {
  background(120);
  imageMode(CORNER);
  image(lastcover, 225, 0, 450, 636);
  fill (255);
  imageMode(CENTER);
  image(me[frameCount%12], width/2, 480, 130, 205);
  image(timmy, 280, 170, 55, 84);
  fill(0);
  textAlign(CENTER);
  textSize(9);
  text("You found all of timmy's belongings", width/2+30, 180);
  text("and saved his christmas!", width/2+30, 200);
  textSize(12);
  text("I wish you just as Timmy have a ", width/2, 290);
  text("merry christmas and a happy new year!", width/2, 320);
  text("Adam", width/2, 350);
  snow1(300);
}

//ADDITIONAL FUNCTIONS
void keyReleased () {
  //stop moving when key is released
  movebool = false;
  if (screen == 1) {
    screen = 2;
  }
}

  //reset key values upon entering new level
void reset () {
  locked = true;
  charcoor[0] = 400;
  charcoor[1] = 300;
  movedir = 4;
  listbool = false;
  opening = true;
}

void mouseReleased () {
  //quit level intro screen
  if ((screen == 2 || screen == 3 || screen == 4) && opening == true) {
    opening = false;
  }
  //quit discovery screen for list
  if (gotbool == true) {
    gotbool = false;
  }
  //quit discovery screen for hat
  if (gothat == true) {
    gothat = false;
  }
  //quit intro screen
  if (screen == 1) {
    screen = 2;
  }
  //when mouse clicked on arrow, go to next level
  if (mouseX >= 576-25 && mouseX <= 576+25 && mouseY >= 560-20 && mouseY <= 560+20 && screen == 0) {
    reset();
    screen = 1;
  }
  if (mouseX >= 840 && mouseX <= 900 && mouseY >= 580 && mouseY <=900 && screen == 2 && locked == false) {
    reset();
    screen = 3;
  }
  if (mouseX >= 840 && mouseX <= 900 && mouseY >= 580 && mouseY <=900 && screen == 3 && locked == false) {
    reset ();
    screen = 4;
  }
  if (mouseX >= 840 && mouseX <= 900 && mouseY >= 580 && mouseY <=900 && screen == 4 && locked == false) {
    screen = 5;
  }
}
